<?php
// Sécurité et récupération des données de configuration
define('OK',1);
include('debut.php');

///////////////////////////////////////////////
// Validation de la requête : matière, n, nb //
///////////////////////////////////////////////

// Recherche de la matière concernée (sur la partie publique, affichage seulement
// si existe ; sur l'interface d'administration, affichage sans condition)
$mysqli = premiere_connexion();
$mysqli->set_charset('utf8');
$resultat = $mysqli->query('SELECT id, cle, nom, cdt FROM matieres WHERE MOD(cdt,2) OR '.var_export($admin,true));
if ( $resultat->num_rows )  {
  if ( !empty($_REQUEST) )
    while ( $r = $resultat->fetch_assoc() )
      if ( isset($_REQUEST[$r['cle']]) )  {
        $matiere = $r;
        break;
      }
  // Matière par défaut : la première
  if ( !isset($matiere) )  {
    $resultat->data_seek(0);
    $matiere = $resultat->fetch_assoc();
  }
  $resultat->free();
}
// Si aucune matière présentant son cahier de texte n'est enregistrée
else  {
  $mysqli->close();
  exit('Cette page ne contient aucune information.');
}

// Fonction d'affichage des semaines
function format_date($date)  {
  $semaine = array('dimanche','lundi','mardi','mercredi','jeudi','vendredi','samedi');
  $mois = array('','janvier','février','mars','avril','mai','juin','juillet','août','septembre','octobre','novembre','décembre');
  return $semaine[substr($date,0,1)].' '.substr($date,7).' '.$mois[intval(substr($date,5,2))].' '.substr($date,1,4);
}

// Récupération des semaines
$resultat = $mysqli->query("SELECT id, DATE_FORMAT(debut,'%w%Y%m%e') AS debut, vacances FROM semaines");
$select_semaines = '';
if ( $resultat->num_rows )  {
  while ( $r = $resultat->fetch_assoc() )  {
    switch ( $r['vacances'] )  {
      case 0:
        $select_semaines .= "\n        <option value=\"${r['id']}\">".format_date($r['debut']).'</option>';
        $sid[] = $r['id'];
        break;
      case 1:
        $select_semaines .= "\n        <option value=\"${r['id']}\" disabled>Vacances de Toussaint</option>";
        break;
      case 2:
        $select_semaines .= "\n        <option value=\"${r['id']}\" disabled>Vacances de Noël</option>";
        break;
      case 3:
        $select_semaines .= "\n        <option value=\"${r['id']}\" disabled>Vacances d'hiver</option>";
        break;
      case 4:
        $select_semaines .= "\n        <option value=\"${r['id']}\" disabled>Vacances de Pâques</option>";
        break;
    }
  }
  $resultat->free();
}
else  {
  $mysqli->close();
  include('installation.php');
}

// Demande de visualisation de toute l'année
if ( isset($_REQUEST['depuisledebut']) )  {
  $n = 1;
  $m = array_search($n,$sid);
  $nb = count($sid);
}
else  {
  // Validation de n (numéro de semaine à voir)
  if ( isset($_REQUEST['n']) && is_numeric($n = $_REQUEST['n']) )  {
    if ( !in_array($n,$sid) )
      $n = 1;
  }
  // Sans argument, on souhaite afficher la semaine actuelle
  else {
    $date = ( isset($_REQUEST['date']) && preg_match('/\d{4}-\d{2}-\d{2}/',$_REQUEST['date']) ) ? '\''.trim($_REQUEST['date'],'\'').'\'' : 'NOW()';
    $resultat = $mysqli->query("SELECT IF(vacances,(SELECT id FROM semaines WHERE debut > $date AND vacances = 0 LIMIT 1),id) AS id
                                FROM semaines WHERE debut < $date ORDER BY debut DESC LIMIT 1");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_assoc();
      $n = $r['id'];
      $resultat->free();
    }
    else
      $n = 1;
  }
  $m = array_search($n,$sid);

  // Validation de nb (nombre de semaines à voir)
  if ( isset($_REQUEST['nb']) && is_numeric($nb = $_REQUEST['nb']) )  {
    if ( $nb < 1 )
      $nb = 1;
    if ( $nb > count($sid) - $m )
      $nb = count($sid) - $m;
  }
  else
    // Par défaut : affichage d'une seule semaine
    $nb = 1;
}

// Récupération des types de séances
$types = array();
$resultat = $mysqli->query("SELECT id, cle, deb_fin_pour FROM `cdt-types` WHERE matiere = ${matiere['id']}");
while ( $r = $resultat->fetch_assoc() )
  $types[$r['id']] = $r;  
$resultat->free();

///////////////////
// Modifications //
///////////////////
if ( ( $admin ) && isset($_REQUEST['id']) && is_numeric($id = $_REQUEST['id']) )  {
  // Connexion à la base de données
  $mysqli->close();
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Vérification que l'identifiant est valide. Défaut : id=0 (nouvelle entrée)
  if ( $id )  {
    $resultat = $mysqli->query("SELECT id FROM cdt WHERE matiere = ${matiere['id']} AND id = $id");
    if ( $resultat->num_rows )
      $resultat->free();
    else
      $id = 0;
  }

  // Sauvegarde de la table contenant les données
  sauvegarde_mysql('cdt');
  
  // Traitement d'un ajout/modification
  if ( isset($_REQUEST['modifie']) && strlen($_REQUEST['texte']) )  {
    
    // Validation du jour : à mettre dans la bonne semaine
    $jour = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['jour']);
    $resultat = $mysqli->query("SELECT id FROM semaines WHERE debut <= '$jour' ORDER BY debut DESC LIMIT 1");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_assoc();
      $resultat->free();
      // Correction éventuelle de n et nb pour que l'entrée soit visible après enregistrement
      $s = array_search($r['id'],$sid);
      if ( ( $s < $m ) || ( $m+$nb <= $s ) )  {
        $n = $r['id'];
        $m = array_search($n,$sid);
        $nb = 1;
      }
      
      // Validation des autres données envoyées
      $tid = ( array_key_exists($_REQUEST['tid'],$types) ) ? $_REQUEST['tid'] : key($types);
      $h_debut = $h_fin = '0:00';
      $pour = '0000/00/00';
      switch ( $types[$tid]['deb_fin_pour'] )  {
        case 1:
          $h_fin = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_fin']);
        case 0:
          $h_debut = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_debut']);
          break;
        case 2:
          $pour = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['pour']);
      }
      $texte = $mysqli->real_escape_string($_REQUEST['texte']);
      $demigroupe = ( isset($_REQUEST['demigroupe']) ) ? 1 : 0;

      // Si $id > 0 : modification d'une entrée existante. Si $id = 0, nouvelle entrée
      // Ordre : d'abord ce qui n'a pas de fin, ensuite les séances "normales", ensuite les "pour le"
      if ( $id )
        $message = ( $mysqli->query("UPDATE cdt SET semaine = ${r['id']},
                                     jour = '$jour', h_debut = '$h_debut', h_fin = '$h_fin', pour = '$pour',
                                     type = $tid, texte = '$texte', demigroupe = $demigroupe WHERE id = $id")
                  && $mysqli->query('ALTER TABLE cdt ORDER BY jour,matiere,pour,h_debut,h_fin,type')
        ) ? 'L\'entrée du cahier de texte a bien été modifiée.' : 'L\'entrée du cahier de texte n\'a pas pu être modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
      else  {
        $cache = ( isset($_REQUEST['cache']) ) ? 1 : 0;
        $message = ( $mysqli->query("INSERT INTO cdt SET semaine = ${r['id']}, matiere = ${matiere['id']},
                                     jour = '$jour', h_debut = '$h_debut', h_fin = '$h_fin', pour = '$pour',
                                     type = $tid, texte = '$texte', demigroupe = $demigroupe, cache = $cache")
                  && $mysqli->query('ALTER TABLE cdt ORDER BY jour,matiere,pour,h_debut,h_fin,type')
        ) ? 'L\'entrée du cahier de texte a bien été ajoutée.' : 'L\'entrée du cahier de texte n\'a pas pu être ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
      }
    }
    else
      $message = 'La date saisie se situe hors de l\'année scolaire.';
  }

  elseif ( $id )  {

    // Positionnement "montré" (apparaît sur la partie publique)
    if ( isset($_REQUEST['montre']) )
      $message = ( $mysqli->query("UPDATE cdt SET cache = 0 WHERE id = $id") ) ? 'L\'entrée du cahier de texte a bien été diffusée, elle apparaît désormais sur la partie publique.' : 'L\'entrée du cahier de texte n\'a pas pu être diffusée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';

    // Positionnement "caché" (n'apparaît plus sur la partie publique)
    elseif ( isset($_REQUEST['cache']) )
      $message = ( $mysqli->query("UPDATE cdt SET cache = 1 WHERE id = $id") ) ? 'L\'entrée du cahier de texte n\'est plus diffusée&nbsp;: elle n\'apparaît plus dans la partie publique mais est toujours disponible ici pour modification ou diffusion.' : 'L\'entrée du cahier de texte n\'a pas pu être cachée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';

    // Suppression
    elseif ( isset($_REQUEST['supprime']) || !strlen($texte) )
      $message = ( $mysqli->query("DELETE FROM cdt WHERE id = $id") ) ? 'L\'entrée du cahier de texte a bien été supprimée.' : 'L\'entrée du cahier de texte n\'a pas pu être supprimée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
  }
    
  // Mise à jour des champs 'cdt' dans la table 'matieres' (pour le menu)
  $mysqli->query('UPDATE matieres SET cdt = cdt - MOD(cdt,2) + IF((SELECT id FROM cdt WHERE matiere = matieres.id AND cache = 0 
  LIMIT 1),1,0)');

  // Passage en connexion MySQL en lecture seulement
  $mysqli->close();
  $mysqli = new mysqli($serveur,$base,$mdp,$base);
  $mysqli->set_charset('utf8');
}

////////////
/// HTML ///
////////////
$p = "cdt?${matiere['cle']}$urladmin";
$t = "Cahier de texte - ${matiere['nom']}";

// Demander l'identification si la page est protégée et l'utilisateur non connecté
if ( ( $matiere['cdt'] == 3 ) && !$admin && !$lecteur )
  include('login_lecture.php');

// Haut de page, menu et message
include('haut.php');

// Formulaire de demande d'affichage
$select_semaines = str_replace("\"$n\"","\"$n\" selected",$select_semaines);
$select_types = $recherche_types = '';
if ( isset($_REQUEST['type']) )
  foreach ( $types as $type )
    if ( $type['cle'] == $_REQUEST['type'] )  {
      $select_types .= "\n        <option value=\"${type['cle']}\" selected>les ${type['cle']}</option>";
      $recherche_types = " AND t.cle = '${type['cle']}'";
    }
    else
      $select_types .= "\n        <option value=\"${type['cle']}\">les ${type['cle']}</option>"; 
else
  foreach ( $types as $type )
    $select_types .= "\n        <option value=\"${type['cle']}\">les ${type['cle']}</option>"; 

$u = strlen($urladmin) ? "\n    <input type=\"hidden\" name=\"admin\" value=\"\">" : '';
echo <<<FIN

  <div class="item" id="recherche">
  <form action="" method="get">
    <input type="hidden" name="${matiere['cle']}" value="">
    <p>Afficher&nbsp;
      <select name="type">
        <option value="tout">tout</option>$select_types
      </select>
      <input type="submit" name="depuisledebut" id="depuisledebut" value="pour toute l'année">
      ou&nbsp;pendant&nbsp;<input type="text" name="nb" value="$nb" size="2">&nbsp;semaine(s) à partir du&nbsp;
      <select name="n">$select_semaines
      </select>
      <input type="submit" name="" value="OK">
    </p>$u
  </form>
  </div>


FIN;

// Aide générale pour l'interface d'administration
if ( $admin )  {
?>
  <div class="item aide">
    <h3>Aide et explications</h3>
    <p>Vous pouvez ci-dessous modifier votre cahier de texte. Vous pouvez choisir les semaines à afficher ci-dessus.</p>
    <p>La case à cocher <em>Ne pas diffuser sur la partie publique</em> permet de cacher temporairement cette entrée du cahier de texte, par exemple pour le diffuser ultérieurement.</p>
    <p>Vous pouvez <em>cacher</em> ou <em>montrer</em> une entrée de cahier de texte existante, c'est-à-dire la diffuser ou non sur la partie publique.</p>
    <p>Vous pouvez supprimer une entrée de cahier de texte existante par le bouton <em>Supprimer</em> ou en validant un texte vide.</p>
    <p>Les semaines sont réglables <a href="semaines">ici</a>.</p>
    <p>Il est possible de permettre l'accès à la page affichant ce cahier de texte uniquement aux visiteurs qui se sont identifiés. Cela est réglable avec vos <a href="prefs">préférences</a>. Il faut alors <a href="utilisateurs">créer un compte</a> de type élève pour permettre aux élèves d'accéder à cette page.</p>
  </div>

  <div class="item">
    <p>Vous pouvez <a href="cdt-seances?<?php echo $matiere['cle']; ?>">définir des boutons de raccourci</a>, qui pré-rempliront les champs type, date, heures et demi-groupe. Ils apparaîtront dans chaque formulaire d'entrée du cahier de texte. Ces boutons sont propres à chaque matière.</p>
    <p>Les types d'entrées du cahier de texte sont aussi <a href="cdt-types?<?php echo $matiere['cle']; ?>">modifiables</a>, indépendamment pour chaque matière.</p>
  </div>

<?php

  // Select des types d'entrée différent du précédent
  $select_types = '';
  foreach ( $types as $type )
    $select_types .= "\n          <option value=\"${type['id']}\">".ucfirst($type['cle']).'</option>';
}

// Fonction d'affichage
function affichage($r)  {
  $semaine = array('','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');
  $pour = ( strlen($r['heure']) ) ? '' : " pour le ${r['pour']}";
  // Affichage partie administrative
  if ( $GLOBALS['admin'] )  {
    if ( $id = $r['id'] )  {
      $debut = "${semaine[$r['jour']]} ${r['date']}${r['heure']}&nbsp;: ${r['titre']}$pour${r['demigroupe']}";
      $valide1 = '';
      $valide = "\n        <input type=\"submit\" name=\"modifie\" value=\"Valider\" title=\"Valider les modifications\">";
      $suppr = "\n        <input type=\"submit\" name=\"supprime\" value=\"Supprimer\" title=\"Supprimer l'entrée\">";
      $cache_nouveau = '';
      if ( $r['cache'] )  {
        $debut .= ' (entrée non diffusée sur la partie publique)';
        $cache_classe = ' cache';
        $cache = "\n        <input type=\"submit\" name=\"montre\" value=\"Montrer\" title=\"Diffuser l'entrée, la rendre visible sur la partie publique\">";
      }
      else  {
        $cache_classe = '';
        $cache = "\n        <input type=\"submit\" name=\"cache\" value=\"Cacher\" title=\"Ne plus diffuser l'entrée, la rendre invisible sur la partie publique\">";
      }
    }
    else  {
      $debut = 'Nouvelle entrée du cahier';
      $valide1 = "\n    <input class=\"bouton\" type=\"submit\" name=\"modifie\" value=\"Valider\" title=\"Valider les modifications\">";
      $valide = $cache = $cache_classe = $suppr = '';
      $cache_nouveau = "\n      <p class=\"ligne\"><label for=\"cache\">Ne pas diffuser sur la partie publique&nbsp;: </label><input type=\"checkbox\" id=\"cache\" name=\"cache\" value=\"1\"></p>";
    }
    $demigroupe = ( strlen($r['demigroupe']) ) ? ' checked' : '';
    $select_types = str_replace("\"${r['tid']}\"","\"${r['tid']}\" selected",$GLOBALS['select_types']);
    $type = ( isset($_REQUEST['type']) ) ? "&amp;type=${_REQUEST['type']}" : '';
    echo <<<FIN
  <div class="item cdt admin$cache_classe">
  <form action="${GLOBALS['p']}&amp;n=${GLOBALS['n']}&amp;nb=${GLOBALS['nb']}$type${GLOBALS['urladmin']}" method="post">$valide1
    <h3>$debut</h3>
    <div>
      <p class="boutons">$valide$cache$suppr
      </p>
      <p class="ligne"><label for="tid$id">Type&nbsp;:</label>
        <select id="tid$id" name="tid">$select_types
        </select>
      </p>
      <p class="ligne"><label for="jour$id">Jour&nbsp;: </label><input type="text" class="date" id="jour$id" name="jour" value="${r['date']}" size="8"></p>
      <p class="ligne"><label for="h_debut$id">Heure de début&nbsp;: </label><input type="text" class="heure" id="h_debut$id" name="h_debut" value="${r['h_debut']}" size="5"></p>
      <p class="ligne"><label for="h_fin$id">Heure de fin&nbsp;: </label><input type="text" class="heure" id="h_fin$id" name="h_fin" value="${r['h_fin']}" size="5"></p>
      <p class="ligne"><label for="pour$id">Pour le&nbsp;: </label><input type="text" class="date" id="pour$id" name="pour" value="${r['pour']}" size="8"></p>
      <p class="ligne"><label for="demigroupe$id">Séance en demi-groupe&nbsp;: </label><input type="checkbox" id="demigroupe$id" name="demigroupe" value="1"$demigroupe></p>
      <textarea name="texte" rows="10" cols="100">${r['texte']}</textarea>$cache_nouveau
      <input type="hidden" name="id" value="$id">
    </div>
  </form>
  </div>


FIN;
  }
  elseif ( !$r['cache'] )
    // Affichage partie publique
    echo <<<FIN
    <div class="item cdt">
      <p class="titre">${semaine[$r['jour']]} ${r['date']}${r['heure']}&nbsp;: ${r['titre']}$pour${r['demigroupe']}</p>
      <div>
  ${r['texte']}
      </div>
    </div>


FIN;
}

// Gestion des titres de nouvelles semaines
$resultat = $mysqli->query("SELECT id, DATE_FORMAT(debut,'%w%Y%m%e') AS debut, vacances 
                            FROM semaines WHERE id BETWEEN $n AND ${sid[$m+$nb-1]}" );
$semaines = array(0=>'');
while ( $r = $resultat->fetch_assoc() )
  switch ( $r['vacances'] )  {
    case 0:
      $semaines[$r['id']] = 'Semaine du '.format_date($r['debut']);
      break;
    case 1:
      $semaines[$r['id']] = ucfirst(format_date($r['debut']))."&nbsp;: Vacances de Toussaint";
      break;
    case 2:
      $semaines[$r['id']] = ucfirst(format_date($r['debut']))."&nbsp;: Vacances de Noël";
      break;
    case 3:
      $semaines[$r['id']] = ucfirst(format_date($r['debut']))."&nbsp;: Vacances d'hiver";
      break;
    case 4:
      $semaines[$r['id']] = ucfirst(format_date($r['debut']))."&nbsp;: Vacances de Pâques";
      break;
  }
$resultat->free();

// Formulaire vide
if ( $admin )
  affichage(array('id' => 0, 'texte' => '&lt;p&gt;Texte&lt;/p&gt;', 'pour' => '00/00/0000', 'date' => date('d/m/Y'),
                  'h_debut' => '08h00', 'h_fin' => '10h00', 'heure' => '', 'demigroupe' => '', 'cache' => 0, 'tid' => ''));

// Liens de navigation vers semaines précédentes/suivantes
$nav = '  <div class="item">';
if ( $m )
  $nav .= "\n    <a class=\"prec\" href=\"?${matiere['cle']}&amp;n=". $sid[max($m-$nb,0)] ."&amp;nb=$nb$urladmin\">Semaines précédentes</a>";
if (  $m+$nb < count($sid) )
  $nav .= "\n    <a class=\"suiv\" href=\"?${matiere['cle']}&amp;n=". $sid[$m+$nb] ."&amp;nb=$nb$urladmin\">Semaines suivantes</a>";
$nav .= "\n  </div>\n\n";
echo $nav;

// Récupération des entrées
$resultat = $mysqli->query("SELECT cdt.id, cdt.texte, cdt.semaine,
                            DATE_FORMAT(cdt.jour,'%w') AS jour, DATE_FORMAT(cdt.jour,'%d/%m/%Y') AS date,
                            CASE t.deb_fin_pour
                              WHEN 0 THEN TIME_FORMAT(cdt.h_debut,' à %kh%i')
                              WHEN 1 THEN CONCAT(TIME_FORMAT(cdt.h_debut,' de %kh%i'),TIME_FORMAT(cdt.h_fin,' à %kh%i'))
                              ELSE '' END AS heure,
                            TIME_FORMAT(cdt.h_debut,'%Hh%i') AS h_debut,
                            TIME_FORMAT(cdt.h_fin,'%Hh%i') AS h_fin,
                            DATE_FORMAT(cdt.pour,'%d/%m/%Y') AS pour,
                            IF(cdt.demigroupe,' (en demi-groupe)','') AS demigroupe, cdt.cache, t.id AS tid, t.titre
                            FROM cdt LEFT JOIN `cdt-types` AS t ON t.matiere = ${matiere['id']} AND t.id = cdt.type
                            WHERE cdt.semaine BETWEEN $n AND ${sid[$m+$nb-1]} AND cdt.matiere = ${matiere['id']} $recherche_types");

// Affichage des résultats
if ( $resultat->num_rows )  {
  $s = $j = 0;
  $semaine = array('','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');

  while ( $r = $resultat->fetch_assoc() )  {
    
    // Affichage d'une div par jour
    if ( ( $j != $r['jour'] ) || ( $s != $r['semaine'] ) )  {
      if ( $j )
        echo "  </div>\n\n";
        // Nouvelle semaine
        while ( ( $s != $r['semaine'] ) && next($semaines) )  {
          echo '  <h2 class="cdtsemaine">'.current($semaines)."</h2>\n\n";
          $s = key($semaines);
        }
      echo "  <div class=\"cdtjour\">\n\n";
      $j = $r['jour'];
    }
    affichage($r);
  }
  $resultat->free();
  echo "  </div>\n\n";
  // Liens de navigation vers semaines précédentes/suivantes
  echo $nav;
}
else  {
  if ( !isset($_REQUEST['type']) || ( $_REQUEST['type'] == 'tout' ) )
    echo "  <h2>Le cahier de texte est vide pour les semaines choisies.</h2>\n\n";
  else
    echo "  <h2>Le cahier de texte ne contient pas de «&nbsp;${_REQUEST['type']}&nbsp;» pour les semaines choisies.</h2>\n\n";
}

// Gestion des boutons de l'interface d'administration
if ( $admin )  {

  // Récupération des boutons
  $resultat = $mysqli->query("SELECT id, nom, jour, TIME_FORMAT(h_debut,'%Hh%i') AS h_debut, TIME_FORMAT(h_fin,'%Hh%i') AS h_fin,
                              type, demigroupe FROM `cdt-seances` WHERE matiere = ${matiere['id']}");
  $raccourcis = '';
  $raccourcisjs = '';
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )  {
      $raccourcis .= "<input type=\"button\" class=\"rac${r['id']}\" value=\"${r['nom']}\"> ";
      $r['demigroupe'] = ( $r['demigroupe'] ) ? 'true' : 'false';
      $raccourcisjs .= <<<FIN
  $('.rac${r['id']}').click(function() {
    $(this).parent().parent().find('[name="tid"]').val('${r['type']}').change();
    $(this).parent().parent().find('[id^="h_debut"]').val('${r['h_debut']}');
    $(this).parent().parent().find('[id^="h_fin"]').val('${r['h_fin']}');
    $(this).parent().parent().find('[id^="demigroupe"]').attr('checked', ${r['demigroupe']});
    var today=new Date();
    var t=today.getDay();
    t = ${r['jour']}-t;
    if ( t>0 ) { t-=7; }
    $(this).parent().parent().find('[id^="jour"]').datepick('setDate',t+'d');
  });

FIN;
    }
    $resultat->free();  
  }

  // Disparition automatique des heures et de la date d'échéance
  echo <<<FIN
  <script type="text/javascript">
$( function() {

  // Modification du formulaire en fonction du type
  $('[name="tid"]').change(function() {
    var p1 = $(this).parent().parent().find('[id^="h_debut"]').parents('.ligne');
    var p2 = $(this).parent().parent().find('[id^="h_fin"]').parents('.ligne');
    var p3 = $(this).parent().parent().find('[id^="pour"]').parents('.ligne');
    switch ( $(this).val() )  {
FIN;
  foreach ( $types as $id => $type )
    switch ( $type['deb_fin_pour'] )  {
      case 0:
        echo "\n      case '$id': p1.show(); p2.hide(); p3.hide(); break;";
        break;
      case 1:
        echo "\n      case '$id': p1.show(); p2.show(); p3.hide(); break;";
        break;
      case 2:
        echo "\n      case '$id': p1.hide(); p2.hide(); p3.show(); break;";
    }
  echo <<<FIN

    }
  });
  // Modification au chargement
  $('[name="tid"]').change();

  // Boutons de raccourcis
  $('<p class="boutons">$raccourcis</p>').clone().insertBefore($('.admin form').find('.ligne:first'));
$raccourcisjs
  $('.date').datepick({dateFormat: 'dd/mm/yyyy', showTrigger: '<img src="js/calendar-blue.gif">'});
  $('.heure').timeEntry({timeSteps: [1, 15, 0],separator: 'h'});

  // URL plus lisible après clic du bouton "Toute l'année"
  $('#depuisledebut').click(function() {
    window.location.search = '?${matiere['cle']}&type='+$(this).prev('[name="type"]').val()+'&depuisledebut';
    return false;
  });

});
  </script>

  <script type="text/javascript" src="textarea.js.php?m=${matiere['id']}"></script>
  

FIN;

}
$mysqli->close();

// Bas de page
include('bas.php');
?>
