<?php
// Sécurité et récupération des données de configuration
define('OK',1);
include('debut.php');

// Recherche de la matière concernée (sur la partie publique, affichage seulement
// si existe ; sur l'interface d'administration, affichage sans condition)
$mysqli = premiere_connexion();
$mysqli->set_charset('utf8');
$resultat = $mysqli->query('SELECT id, cle, nom, colles FROM matieres WHERE MOD(colles,2) OR '.var_export($admin,true));
if ( $resultat->num_rows )  {
  if ( !empty($_REQUEST) )
    while ( $r = $resultat->fetch_assoc() )
      if ( isset($_REQUEST[$r['cle']]) )  {
        $matiere = $r;
        break;
      }
  // Matière par défaut : la première
  if ( !isset($matiere) )  {
    $resultat->data_seek(0);
    $matiere = $resultat->fetch_assoc();
  }
  $resultat->free();
}
// Si aucune matière présentant son programme de colles n'est enregistrée
else  {
  $mysqli->close();
  exit('Cette page ne contient aucune information.');
}

///////////////////
// Modifications //
///////////////////
if ( ( $admin ) && isset($_REQUEST['id']) && is_numeric($id = $_REQUEST['id']) )  {
  // Connexion à la base de données
  $mysqli->close();
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Vérification que l'identifiant de la semaine est valide
  $resultat = $mysqli->query("SELECT DATE_FORMAT(s.debut,'%e/%m') AS debut, c.id, c.cache, c.texte FROM semaines AS s
                              LEFT JOIN (SELECT id, texte, semaine, cache FROM colles WHERE matiere = ${matiere['id']}) AS c ON c.semaine=s.id
                              WHERE s.id = $id AND s.colle = 1");
  if ( $resultat->num_rows ) {
    $r = $resultat->fetch_assoc();
    $cid = $r['id'];
    $resultat->free();
    $_REQUEST['n'] = $id;
    
    // Sauvegarde de la table contenant les données
    sauvegarde_mysql('colles');

    // Pour les informations récentes
    $titre_recent = "<img class=\"icone\" src=\"icones/colle.png\"> Colles du ${r['debut']} en ".addslashes($matiere['nom']);
    $lien_recent = 'colles?'.addslashes($matiere['cle'])."&amp;n=$id";

    // Ajout d'un nouveau programme de colles. Il ne faut pas pouvoir insérer un programme vide par erreur
    if ( isset($_REQUEST['modifie']) && strlen($_REQUEST['texte']) )  {
      
      // Validation des données envoyées
      $texte = $mysqli->real_escape_string($_REQUEST['texte']);
      
      // Si $cid n'est pas NULL : modification d'un programme existant. Sinon, nouveau programme
      if ( $cid )  {
        if ( $mysqli->query("UPDATE colles SET texte = '$texte' WHERE id = $cid") )  {
          $message = "Le programme de colles de la semaine du ${r['debut']} a bien été modifié.";
          // Ajout d'une information récente si programme diffusé
          if ( !$r['cache'] )
            recent($mysqli,2,$cid,$titre_recent,$lien_recent,$texte);
        }
        else
          $message = "Le programme de colles de la semaine du ${r['debut']} n'a pas pu être modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }
      else  {
        $cache = ( isset($_REQUEST['cache']) ) ? 1 : 0;
        if ( $mysqli->query("INSERT INTO colles SET texte = '$texte', semaine = $id, matiere = ${matiere['id']}, cache = $cache") )  {
          $message = "Le programme de colles de la semaine du ${r['debut']} a bien été ajouté.";
          // Ajout d'information récente si programme diffusé
          if ( !$cache )
            recent($mysqli,2,$mysqli->insert_id,$titre_recent,$lien_recent,$texte);
          $mysqli->query('ALTER TABLE colles ORDER BY matiere,semaine');
        }
        else
          $message = "Le programme de colles de la semaine du ${r['debut']} n'a pas pu être ajouté. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }
    }

    elseif ( $cid )  {

      // Positionnement "montré" (apparaît sur la partie publique)
      if ( isset($_REQUEST['montre']) )  {
        if ( $mysqli->query("UPDATE colles SET cache = 0 WHERE id = $cid") )  {
          $message = "Le programme de colles de la semaine du ${r['debut']} a bien été diffusé, il apparaît désormais sur la partie publique.";
          // Ajout d'information récente
          recent($mysqli,2,$cid,$titre_recent,$lien_recent,$mysqli->real_escape_string($r['texte']));
        }
        else
          $message = "Le programme de colles de la semaine du ${r['debut']} n'a pas pu être diffusé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }

      // Positionnement "caché" (n'apparaît pas sur la partie publique)
      elseif ( isset($_REQUEST['cache']) )  {
        if ( $mysqli->query("UPDATE colles SET cache = 1 WHERE id = $cid") )  {
          $message = "Le programme de colles du ${r['debut']} n'est plus diffusé&nbsp;: il n'apparaît plus sur la partie publique mais est toujours disponible ici pour modification ou diffusion.";
          // Suppression de l'éventuelle information récente
          recent($mysqli,2,$cid);
        }
        else
          $message = "Le programme de colles de la semaine du ${r['debut']} n'a pas pu être caché. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }

      // Suppression
      elseif ( isset($_REQUEST['supprime']) || !strlen($_REQUEST['texte']) )  {
        if ( $mysqli->query("DELETE FROM colles WHERE id = $cid") )  {
          $message = "Le programme de colles de la semaine du ${r['debut']} a bien été supprimé.";
          // Suppression de l'éventuelle information récente
          recent($mysqli,2,$cid);
        }
        else
          $message = "Le programme de colles de la semaine du ${r['debut']} n'a pas pu être modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }
    }
  }
  
  // Mise à jour des champs 'colles' dans la table 'matieres' (pour le menu)
  $mysqli->query('UPDATE matieres SET colles = colles - MOD(colles,2) + IF((SELECT id FROM colles WHERE matiere = matieres.id AND cache = 0 LIMIT 1),1,0)');

  // Passage en connexion MySQL en lecture seulement
  $mysqli->close();
  $mysqli = new mysqli($serveur,$base,$mdp,$base);
  $mysqli->set_charset('utf8');
}

//////////////////////////////////////
// Validation de la requête : n, nb //
//////////////////////////////////////

// Fonction d'affichage des semaines
function format_date($date)  {
  $semaine = array('dimanche','lundi','mardi','mercredi','jeudi','vendredi','samedi');
  $mois = array('','janvier','février','mars','avril','mai','juin','juillet','août','septembre','octobre','novembre','décembre');
  return $semaine[substr($date,0,1)].' '.substr($date,7).' '.$mois[intval(substr($date,5,2))].' '.substr($date,1,4);
}

// Récupération des semaines
$resultat = $mysqli->query("SELECT s.id AS sid, DATE_FORMAT(s.debut,'%w%Y%m%e') AS d, s.colle, s.vacances, c.id AS cid, c.cache
                            FROM semaines AS s
                            LEFT JOIN (SELECT id, semaine, cache FROM colles WHERE matiere = ${matiere['id']}) AS c ON c.semaine=s.id");
$select_semaines = '';
if ( $resultat->num_rows )  {
  while ( $r = $resultat->fetch_assoc() )  {
    switch ( $r['vacances'] )  {
      case 0:
        if ( $admin )  {
          if ( $r['colle'] )  {
            if ( is_null($r['cid']) )
              $select_semaines .= "\n        <option value=\"${r['sid']}\">".format_date($r['d']).'</option>';
            elseif ( $r['cache'] )
              $select_semaines .= "\n        <option value=\"${r['sid']}\">".format_date($r['d']).' (non diffusé)</option>';
            else
              $select_semaines .= "\n        <option value=\"${r['sid']}\">".format_date($r['d']).' (déjà rempli)</option>';
          }
          else
            $select_semaines .= "\n        <option value=\"${r['sid']}\" disabled>".format_date($r['d']).' (pas de colle)</option>';
        }
        else
          $select_semaines .= ( is_null($r['cid']) || $r['cache'] ) ? "\n        <option value=\"${r['sid']}\" disabled>".format_date($r['d']).'</option>' : "\n        <option value=\"${r['sid']}\">".format_date($r['d']).'</option>';
        $sid[] = $r['sid'];
        break;
      case 1:
        $select_semaines .= "\n        <option value=\"${r['sid']}\" disabled>Vacances de Toussaint</option>";
        break;
      case 2:
        $select_semaines .= "\n        <option value=\"${r['sid']}\" disabled>Vacances de Noël</option>";
        break;
      case 3:
        $select_semaines .= "\n        <option value=\"${r['sid']}\" disabled>Vacances d'hiver</option>";
        break;
      case 4:
        $select_semaines .= "\n        <option value=\"${r['sid']}\" disabled>Vacances de Pâques</option>";
    }
  }
  $resultat->free();
}
else  {
  $mysqli->close();
  include('installation.php');
}

// Validation de n (numéro de semaine à voir)
if ( isset($_REQUEST['n']) && is_numeric($n = $_REQUEST['n']) )  {
  if ( !in_array($n,$sid) )
    $n = 1;
}
// Sans argument, on souhaite afficher le programme de colles de la semaine actuelle
else {
  $date = ( isset($_REQUEST['date']) && preg_match('/\d{4}-\d{2}-\d{2}/',$_REQUEST['date']) ) ? '\''.trim($_REQUEST['date'],'\'').'\'' : 'NOW()';
  $resultat = $mysqli->query("SELECT IF(vacances,(SELECT id FROM semaines WHERE debut > ADDDATE($date,3) AND vacances = 0 LIMIT 1),id) AS id
                              FROM semaines WHERE debut < ADDDATE($date,3) ORDER BY debut DESC LIMIT 1");
  if ( $resultat->num_rows )  {
    $r = $resultat->fetch_assoc();
    $n = $r['id'];
    $resultat->free();
    if ( $admin && ( $m = array_search($n,$sid) ) )
      $n = $sid[$m-1];
  }
  // Aucun résultat : l'année n'a pas encore commencé
  else
    $n = 0;
}
$m = array_search($n,$sid);

// Validation de nb (nombre de semaines à voir)
if ( isset($_REQUEST['nb']) && is_numeric($nb = $_REQUEST['nb']) ) {
  if ( $nb < 1 )
    $nb = 1;
}
else
  // Par défaut : affichage de la semaine courante en partie publique, affichage
  // aussi des semaines précédente et suivante sur l'interface d'administration
  $nb = 1 + 2*$admin;
if ( $nb > count($sid) - $m )
  $nb = count($sid) - $m;

////////////
/// HTML ///
////////////
$p = "colles?${matiere['cle']}$urladmin";
$t = "Programme de colles - ${matiere['nom']}";

// Demander l'identification si la page est protégée et l'utilisateur non connecté
if ( ( $matiere['colles'] == 3 ) && !$admin && !$lecteur )
  include('login_lecture.php');

// Haut de page, menu et message
include('haut.php');

// Formulaire de demande d'affichage
$select_semaines = str_replace("\"$n\"","\"$n\" selected",$select_semaines);
$u = strlen($urladmin) ? "\n    <input type=\"hidden\" name=\"admin\" value=\"\">" : '';
echo <<<FIN

  <div class="item" id="recherche">
  <form action="" method="get">
    <input type="hidden" name="${matiere['cle']}" value="">
    <p>Afficher&nbsp;<input type="text" name="nb" value="$nb" size="2">&nbsp;semaine(s) à partir du&nbsp;
      <select name="n">$select_semaines
      </select>
      <input type="submit" name="" value="OK">
    </p>$u
  </form>
  </div>


FIN;

// Aide générale pour l'interface d'administration
if ( $admin )  {
?>
  <div class="item aide">
    <h3>Aide et explications</h3>
    <p>Vous pouvez ci-dessous modifier les programmes de colles. Vous pouvez choisir les semaines à afficher ci-dessus.</p>
    <p>La case à cocher <em>Ne pas diffuser sur la partie publique</em> permet de cacher temporairement ce programme de colle, par exemple pour le diffuser ultérieurement.</p>
    <p>Vous pouvez <em>cacher</em> ou <em>montrer</em> un programme de colles existant, c'est-à-dire le diffuser ou non sur la partie publique.</p>
    <p>Vous pouvez supprimer un programme de colles existant par le bouton <em>Supprimer</em> ou en validant un texte vide.</p>
    <p>Les semaines sont réglables <a href="semaines">ici</a>.</p>
    <p>Il est possible de permettre l'accès à la page affichant ces programmes de colles uniquement aux visiteurs qui se sont identifiés. Cela est réglable avec vos <a href="prefs">préférences</a>. Il faut alors <a href="utilisateurs">créer un compte</a> de type élève pour permettre aux élèves d'accéder à cette page.</p>
  </div>

<?php
}

// Affichage des semaines concernées
if ( $n )  {

  // Liens de navigation vers semaines précédentes/suivantes
  $nav = '  <div class="item">';
  if ( $m )
    $nav .= "\n    <a class=\"prec\" href=\"?${matiere['cle']}&amp;n=". $sid[max($m-$nb,0)] ."&amp;nb=$nb$urladmin\">Semaines précédentes</a>";
  if (  $m+$nb < count($sid) )
    $nav .= "\n    <a class=\"suiv\" href=\"?${matiere['cle']}&amp;n=". $sid[$m+$nb] ."&amp;nb=$nb$urladmin\">Semaines suivantes</a>";
  $nav .= "\n  </div>\n\n";
  if ( $nb > 1 )
    echo $nav;

  if ( $admin )
  // Récupération des données à afficher
    $resultat = $mysqli->query("SELECT DATE_FORMAT(s.debut,'%w%Y%m%e') AS d, s.colle, s.vacances, c.texte, s.id, IF(c.cache,' checked','') AS cache 
                                FROM semaines AS s
                                LEFT JOIN (SELECT texte, semaine, cache FROM colles WHERE matiere = ${matiere['id']}) AS c ON c.semaine=s.id
                                WHERE s.id BETWEEN $n AND ${sid[$m+$nb-1]}" );
  else
    $resultat = $mysqli->query("SELECT DATE_FORMAT(s.debut,'%w%Y%m%e') AS d, s.colle, s.vacances, c.texte 
                                FROM semaines AS s
                                LEFT JOIN (SELECT texte, semaine FROM colles WHERE matiere = ${matiere['id']} AND cache = 0) AS c ON c.semaine=s.id
                                WHERE s.id BETWEEN $n AND ${sid[$m+$nb-1]}" );
  // Gestion du titre
  while ( $r = $resultat->fetch_assoc() )  {
    switch ( $r['vacances'] )  {
      case 0:
        $titre = 'Semaine du '.format_date($r['d']);
        break;
      case 1:
        $titre = ucfirst(format_date($r['d']))."&nbsp;: Vacances de Toussaint";
        break;
      case 2:
        $titre = ucfirst(format_date($r['d']))."&nbsp;: Vacances de Noël";
        break;
      case 3:
        $titre = ucfirst(format_date($r['d']))."&nbsp;: Vacances d'hiver";
        break;
      case 4:
        $titre = ucfirst(format_date($r['d']))."&nbsp;: Vacances de Pâques";
        break;
    }
    // Affichage, différent en partie publique/interface d'administration, et pour
    //  une semaine avec ou sans colles
    if ( $admin )  {
      if ( $r['colle'] )  {
        if ( is_null($r['texte']) )  {
          $titre .= ' (à remplir)';
          $valide1 = "\n    <input class=\"bouton\" type=\"submit\" name=\"modifie\" value=\"Valider\" title=\"Valider les modifications\">";
          $classe_cache = $boutons = '';
          $cache = "\n    <p class=\"ligne\"><label for=\"cache\">Ne pas diffuser sur la partie publique&nbsp;: </label><input type=\"checkbox\" id=\"cache\" name=\"cache\" value=\"1\"></p>";
        }
        else  {
          if ( $r['cache'] )  {
            $valide1 = $cache = '';
            $classe_cache = ' cache';
            $titre .= ' (programme non diffusé sur la partie publique)';
            $boutons = "
    <p class=\"boutons\">
      <input type=\"submit\" name=\"modifie\" value=\"Valider\" title=\"Valider les modifications sur le texte\">
      <input type=\"submit\" name=\"montre\" value=\"Montrer\" title=\"Diffuser le programme, le rendre visible sur la partie publique\">
      <input type=\"submit\" name=\"supprime\" value=\"Supprimer\" title=\"Supprimer le programme de colles\">
    </p>";
          }
          else  {
            $valide1 = $cache = $classe_cache = '';
            $boutons = "
    <p class=\"boutons\">
      <input type=\"submit\" name=\"modifie\" value=\"Valider\" title=\"Valider les modifications sur le texte\">
      <input type=\"submit\" name=\"cache\" value=\"Cacher\" title=\"Ne plus diffuser le programme, le rendre invisible sur la partie public\">
      <input type=\"submit\" name=\"supprime\" value=\"Supprimer\" title=\"Supprimer le programme de colles\">
    </p>";
          }
        }
        echo <<<FIN
  <div class="item admin$classe_cache">
  <form action="" method="post">$valide1
    <h3>$titre</h3>$boutons
    <textarea name="texte" rows="15" cols="100">${r['texte']}</textarea>$cache
    <input type="hidden" name="id" value="${r['id']}">
  </form>
  </div>


FIN;
      }
      else  {
        $texte = ( $r['vacances'] ) ? '' : "\n    <p>Il n'y a normalement pas de colles cette semaine-là. S'il s'agit d'une erreur, cela est modifiable <a href=\"semaines\">sur la page des semaines</a></p>";
        echo <<<FIN
  <div class="item admin">
    <h3>$titre</h3>$texte
  </div>


FIN;
      }
    }
    else  {
      if ( $r['colle'] )  {
        $texte = ( is_null($r['texte']) ) ? '    <p>Le programme de colles de cette semaine n\'est pas défini.</p>' : $r['texte'];
        echo <<<FIN
  <div class="item colle">
    <h3>$titre</h3>
$texte
  </div>


FIN;
      }
      else  {
        $texte = ( $r['vacances'] ) ? '' : "\n    <p>Il n'y a pas de colles cette semaine.</p>";
        echo <<<FIN
  <div class="item admin">
    <h3>$titre</h3>$texte
  </div>


FIN;
      }
    }
  }
  $resultat->free();
  // Liens de navigation vers semaines précédentes/suivantes
  echo $nav;
}
else
  echo "  <h2>L'année n'a pas encore commencé... Revenez à la rentrée&nbsp;!</h2>\n\n";
$mysqli->close();

if ( $admin )
  echo "  <script type=\"text/javascript\" src=\"textarea.js.php?m=${matiere['id']}\"></script>\n\n";

// Bas de page
include('bas.php');
?>
