<?php
// Sécurité : ne doit pas être exécuté s'il n'est pas lancé par un script autorisé
if ( !defined('OK') )  exit();

// La connexion MySQL (lien $mysqli) doit être obligatoirement établie par le script appelant.
// $t et $p doivent être réglés par le script appelant
// $t = titre de la page, $p = cle de la page
?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <title><?php echo $t; ?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <link rel="stylesheet" href="css/style.css?v=4" type="text/css" media="screen">
  <link rel="stylesheet" href="css/print.css" type="text/css" media="print">
  <link rel="stylesheet" href="css/couleurs.css?v=4" type="text/css" media="screen">
  <script type="text/javascript" src="js/jquery.js"></script>
  <script type="text/javascript" src="/MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
<?php
if ( $lecteur )
  echo "  <link rel=\"alternate\" type=\"application/rss+xml\" title=\"Flux RSS\" href=\"http://cahier-de-prepa.fr/$site/documents/".sha1($GLOBALS['base'])."/rss.xml\">\n";
else  {
  $resultat = $mysqli->query('SELECT id FROM utilisateurs WHERE matieres = \'0\'');
  if ( $resultat->num_rows )
    $resultat->free();
  else
    echo "  <link rel=\"alternate\" type=\"application/rss+xml\" title=\"Flux RSS\" href=\"http://cahier-de-prepa.fr/$site/documents/".sha1($GLOBALS['base'])."/rss.xml\">\n";
}
if ( $admin )
echo <<< FIN
  <link rel="stylesheet" href="js/jquery.datepick.css" type="text/css">
  <link rel="stylesheet" href="js/jquery.timeentry.css" type="text/css">
  <script type="text/javascript" src="js/jquery.datepick.js"></script>
  <script type="text/javascript" src="js/jquery.datepick-fr.js"></script>
  <script type="text/javascript" src="js/jquery.timeentry.js"></script>
  <script type="text/javascript" src="js/jquery.timeentry-fr.js"></script>
  <script type="text/javascript" src="js/timeout.js"></script>

FIN;
?>
  <script type="text/x-mathjax-config">
    MathJax.Hub.Config({tex2jax: {inlineMath: [["$","$"],["\\(","\\)"]]}});
  </script>
</head>
<body>
<div id="global">

<h1><?php echo $t; ?></h1>

<div id="colonne">

  <div id="menu">
<?php
// Menu de l'interface d'administration et bouton de déconnexion
// Rappel : $p doit être déjà définie (clé correspondant à la page)
if ( $admin )  {
  
  // Début : déconnexion, accueil, documents toutes matières
  $menu = <<<FIN
    <div>
      <form id="deconnexion" action="" method="post"><input type="submit" name="deconnexion" value="Se déconnecter"></form>
      <a href=".$urladmin2">Accueil</a>
      <a href="prefs$urladmin2">Préférences</a>
      <a href="docs$urladmin2">Documents (toutes matières)</a>
FIN;
  $resultat = $mysqli->query("SELECT id, nom FROM reps WHERE matiere = 0 AND menu = 1");
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )
      $menu .= "\n        <a class=\"menurep\" href=\"docs?rep=${r['id']}$urladmin\">${r['nom']}</a>";        
    $resultat->free();
  }
  $menu .= "\n    </div>\n";

  // Matières à afficher dans le menu
  $resultat = $mysqli->query("SELECT id, cle, nom, colles, cdt, docs FROM matieres WHERE FIND_IN_SET(id,'${_SESSION['matieres']}') ORDER BY FIND_IN_SET(id,'${_SESSION['matieres']}')");
  $matieres = array();
  while ( $r = $resultat->fetch_assoc() )  {
    // Stockage utilisé dans admin.php, prefs.php, pages.php
    $matieres[] = $r;
    // Pour le menu
    $menu .= <<<FIN
    <div>
      <h3>Matière <em>${r['nom']}</em></h3>
      <a href="colles?${r['cle']}$urladmin">Programme de colles</a>
      <a href="cdt?${r['cle']}$urladmin">Cahier de texte</a>
      <a href="docs?${r['cle']}$urladmin">Documents</a>
FIN;
    if ( $r['docs'] )  {
      $resultat_doc = $mysqli->query("SELECT id, nom FROM reps WHERE matiere = ${r['id']} AND menu = 1");
      if ( $resultat_doc->num_rows )  {
        while ( $d = $resultat_doc->fetch_assoc() )
          $menu .= "\n        <a class=\"menurep\" href=\"docs?rep=${d['id']}$urladmin\">${d['nom']}</a>";        
        $resultat_doc->free();
      }
    }
    $menu .= "\n    </div>\n";
  }
  $resultat->free();

  // Pages d'informations
  $menu .= <<<FIN
    <div>
      <h3>Pages d'informations</h3>
FIN;
  $resultat = $mysqli->query("SELECT CONCAT_WS('/',m.cle,p.cle) AS cle, CONCAT_WS('/',m.nom,p.nom) AS nom
                              FROM pages AS p LEFT JOIN matieres AS m ON p.mat = m.id
                              WHERE FIND_IN_SET(p.mat,'0,${_SESSION['matieres']}')
                              ORDER BY FIND_IN_SET(p.mat,'0,${_SESSION['matieres']}'), p.ordre");
  while ( $r = $resultat->fetch_assoc() )
    $menu .= "\n      <a href=\".?${r['cle']}$urladmin\">${r['nom']}</a>";
  $resultat->free();
  
  // Paramètres du site et lien vers la partie publique
  $menu .= <<<FIN

    </div>
    <div>
      <h3>Paramètres du site</h3>
      <a href="utilisateurs$urladmin2">Les utilisateurs</a>
      <a href="matieres$urladmin2">Les matières</a>
      <a href="pages$urladmin2">Les pages du site</a>
      <a href="semaines$urladmin2">Les semaines du planning annuel</a>
    </div>
    <div>
      <a href="http://$site/">Voir le site public (pensez à revenir vous déconnecter...)</a>
    </div>
FIN;
  
}
else  {
  // Menu de la partie publique : pages d'informations, page de
  // téléchargement des documents, pages des programmes de colles/cahiers
  // de texte/téléchargement pour chaque matière.
  // Rappel : $p doit être déjà définie (clé correspondant à la page)

  // Récupération et affichage des pages
  $menu = '    <div>';
  $resultat = $mysqli->query('SELECT cle, nom FROM pages WHERE mat = 0');
  while ( $r = $resultat->fetch_assoc() )
    $menu .= "\n      <a href=\".?${r['cle']}\">${r['nom']}</a>";
  $resultat->free();
  // Page de téléchargement
  $menu .= "\n      <a href=\"docs\">Documents à télécharger</a>";
  $resultat = $mysqli->query("SELECT id, nom FROM reps WHERE matiere = 0 AND menu = 1");
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )
      $menu .= "\n        <a class=\"menurep\" href=\"docs?rep=${r['id']}\">${r['nom']}</a>";        
    $resultat->free();
  }
  $menu .= "\n    </div>";

  // Récupération et affichage des matières
  $resultat = $mysqli->query('SELECT m.id, m.cle, m.nom, MOD(m.colles,2) AS colles, MOD(m.cdt,2) AS cdt, m.docs,
                              GROUP_CONCAT(CONCAT(m.cle,\'/\',p.cle) SEPARATOR \'//\') AS pcle,
                              GROUP_CONCAT(p.nom SEPARATOR \'//\') AS pnom
                              FROM matieres AS m LEFT JOIN pages AS p ON p.mat = m.id
                              WHERE MOD(m.colles,2)+MOD(m.cdt,2)+m.docs OR p.nom IS NOT NULL GROUP BY m.id ORDER BY m.ordre, p.ordre');
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )  {
      $menu .= "\n    <div>\n      <h3>${r['nom']}</h3>";
      if ( !is_null($r['pcle']) )  {
        $pcle = explode('//',$r['pcle']);
        $pnom = explode('//',$r['pnom']);
        $nom = $pnom[0];
        foreach ( $pcle as $cle )  {
          $menu .= "\n      <a href=\".?$cle\">$nom</a>";
          $nom = next($pnom);
        }
      }
      if ( $r['colles'] )
        $menu .= "\n      <a href=\"colles?${r['cle']}\">Programme de colles</a>";
      if ( $r['cdt'] )
        $menu .= "\n      <a href=\"cdt?${r['cle']}\">Cahier de texte</a>";
      if ( $r['docs'] )  {
        $menu .= "\n      <a href=\"docs?${r['cle']}\">Documents à télécharger</a>";
        $resultat_doc = $mysqli->query("SELECT id, nom FROM reps WHERE matiere = ${r['id']} AND menu = 1");
        if ( $resultat_doc->num_rows )  {
          while ( $d = $resultat_doc->fetch_assoc() )
            $menu .= "\n        <a class=\"menurep\" href=\"docs?rep=${d['id']}\">${d['nom']}</a>";        
          $resultat_doc->free();
        }
      }
      $menu .= "\n    </div>";
    }
    $resultat->free();
  }
  
  // Lien vers l'interface d'administration
  $proto = ( $https ) ? 'https://' : 'http://';
  $menu .= "\n    <div>\n      <a href=\"".( ( strlen($siteadmin) ) ? $proto.$siteadmin : "$proto$site/?admin" )."\">Administration du site</a>\n    </div>";
}

// Affichage du menu
echo str_replace("a href=\"$p\"","a id=\"actuel\" href=\"$p\"",$menu);
?>

  </div>

<?php
// Affichage des informations récentes : seulement sur la partie publique
if ( !$admin )  {
  $resultat = $mysqli->query('SELECT titre, lien FROM recents WHERE DATEDIFF(NOW(),heure) < 10 LIMIT 20');
  if ( $resultat->num_rows )  {
    $aff = '';
    while ( $r = $resultat->fetch_assoc() )
      $aff .= "\n    <a href=\"${r['lien']}\" title=\"".substr($r['titre'],strpos($r['titre'],'>')+2)."\">${r['titre']}</a>";
    $resultat->free();
    echo <<<FIN
  <div id="recent">
    <h3><a href="rss" id="rss"><img class="icone" src="icones/rss.png" alt="Flux RSS"></a> Infos récentes </h3>$aff
  </div>


FIN;
  }
}
?>
</div>

<div id="contenu">
<?php
// Conditionnement du message éventuel
if ( isset($message) )
  echo "\n  <div class=\"warning\">$message</div>\n";
?>
