<?php
// Sécurité et récupération des données de configuration
// Mode admin obligatoire (OK=2)
define('OK',2);
include('debut.php');

///////////////////
// Modifications //
///////////////////
if ( isset($_REQUEST['id']) && is_numeric($id = $_REQUEST['id']) )  {
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Vérification que l'identifiant est valide. Défaut : id=0 (nouvelle page)
  if ( $id )  {
    $resultat = $mysqli->query("SELECT id, nom, ordre, MOD(colles,2)+MOD(cdt,2)+docs AS nonvide, (SELECT MAX(m.ordre) FROM matieres AS m) AS max FROM matieres WHERE id = $id");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_assoc();
      $resultat->free();
      $nom = $r['nom'];
      $ordre = $r['ordre'];
    }
    else
      $id = 0;
  }

  // Ajout ou modification d'une matière
  if ( isset($_REQUEST['modifie']) )  {
    // Vérification des données envoyées
    if ( !strlen($_REQUEST['cle']) || !strlen($_REQUEST['nom']) )
      $message = 'Il n\'est pas possible de valider une matière sans clé ou sans nom. Pour supprimer une matière, il faut cliquer sur Supprimer.';
    else  {
      // Sauvegarde des tables contenant les données
      sauvegarde_mysql('matieres');
      sauvegarde_mysql('reps');
      // Validation des données envoyées
      $cle = $mysqli->real_escape_string($_REQUEST['cle']);
      $nom = $mysqli->real_escape_string($_REQUEST['nom']);
      $colles = ", colles = IF((SELECT id FROM colles WHERE matiere = $id AND cache = 0 LIMIT 1),".( ( isset($_REQUEST['colles']) ) ? '3,2)' : '1,0)');
      $cdt = ", cdt = IF((SELECT id FROM cdt WHERE matiere = $id AND cache = 0 LIMIT 1),".( ( isset($_REQUEST['cdt']) ) ? '3,2)' : '1,0)');
      // Si identifiant numérique non nul, modification d'une matière existante
      if ( $id )
        $message = ( $mysqli->query("UPDATE matieres SET cle = '$cle', nom = '$nom'$colles$cdt WHERE id = $id")
                  && $mysqli->query("UPDATE reps SET nom = '$nom' WHERE matiere = $id AND parent = 0")
        ) ? 'La matière <em>'.stripslashes($nom).'</em> a bien été modifiée.' : "La matière <em>${r['nom']}</em> n'a pas pu être modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      // Si id = 0, ajout d'une nouvelle matière
      else  {
        $colles = ( isset($_REQUEST['colles']) ) ? 2 : 0;
        $cdt = ( isset($_REQUEST['cdt']) ) ? 2 : 0;
        $message = ( $mysqli->query("INSERT INTO matieres SET cle = '$cle', nom = '$nom', colles = '$colles', cdt = '$cdt', docs = 0, ordre = ((SELECT MAX(m.ordre) FROM matieres AS m)+1)")
                  && ( $id = $mysqli->insert_id )
                  && $mysqli->query("INSERT INTO reps SET parent = 0, parents = 0, nom = '$nom', matiere = $id, nbrep = 0, nbdoc_v = 0, nbdoc_nv = 0, protection = 0")
                  && $mysqli->query("INSERT INTO `cdt-types` (matiere, ordre, cle, titre, deb_fin_pour) VALUES
                                                             ($id, 1, 'cours', 'Cours', 1),
                                                             ($id, 2, 'TD', 'Séance de travaux dirigés', 1),
                                                             ($id, 3, 'TP', 'Séance de travaux pratiques', 1),
                                                             ($id, 4, 'DS', 'Devoir surveillé', 1),
                                                             ($id, 5, 'interros', 'Interrogation de cours', 0),
                                                             ($id, 6, 'distributions', 'Distribution de document', 0),
                                                             ($id, 7, 'DM', 'Devoir maison', 2)")
        ) ? 'La matière <em>'.stripslashes($nom).'</em> a bien été ajoutée.' : 'La matière <em>'.stripslashes($nom).'</em> n\'a pas pu être ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
      }
    }
  }

  elseif ( $id )  {
    
    // Sauvegarde de la table contenant les données
    sauvegarde_mysql('matieres');

    // Déplacement vers le haut
    if ( isset($_REQUEST['monte']) && ( $ordre > 1 ) )
      $message = ( $mysqli->query("UPDATE matieres SET ordre = (2*$ordre-1-ordre) WHERE ordre = $ordre OR ordre = ($ordre-1)")
                && $mysqli->query('ALTER TABLE matieres ORDER BY ordre')
      ) ? "La matière <em>$nom</em> a bien été montée d'une place." : "La matière <em>$nom</em> n'a pas pu être déplacée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';

    // Déplacement vers le bas
    elseif ( isset($_REQUEST['descend']) && ( $ordre < $r['max'] ) )
      $message = ( $mysqli->query("UPDATE matieres SET ordre = (2*$ordre+1-ordre) WHERE ordre = $ordre OR ordre = ($ordre+1)")
                && $mysqli->query('ALTER TABLE matieres ORDER BY ordre')
      ) ? "La matière <em>$nom</em> a bien été descendue d'une place." : "La matière <em>$nom</em> n'a pas pu être déplacée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';

    // Suppression
    elseif ( isset($_REQUEST['supprime']) && ( $r['max'] > 1 ) )  {
      // La suppression est impossible si la matière n'est pas vide
      if ( $r['nonvide'] )
        $message = "La matière <em>$nom</em> n'a pas pu être supprimée&nbsp;: ses programmes de colles, son cahier de texte ou ses documents ne sont pas vides. Il faut supprimer l'ensemble de ces données pour pouvoir supprimer une matière.";
      // La suppression est impossible si la matière est associée à qqun
      else  {
        $resultat = $mysqli->query("SELECT id FROM utilisateurs WHERE FIND_IN_SET($id,matieres)");
        if ( $resultat->num_rows )  {
          $message = "La matière <em>$nom</em> n'a pas pu être supprimée&nbsp;: elle est associée à au moins un utilisateur. Il faut que chaque utilisateur concerné supprime lui-même son association à cette matière.";
          $resultat->free();
        }
        else
          $message = ( $mysqli->query("DELETE FROM matieres WHERE id = $id")
                    && $mysqli->query("UPDATE matieres SET ordre = (ordre-1) WHERE ordre > $ordre")
                    && $mysqli->query("DELETE FROM `cdt-types` WHERE matiere = $id")
                    && $mysqli->query("DELETE FROM `cdt-seances` WHERE matiere = $id")
                    && $mysqli->query("DELETE FROM reps WHERE matiere = $id")
                    && $mysqli->query("UPDATE pages SET mat = 0 WHERE mat = $id")
          ) ? "La matière <em>$nom</em> a bien été supprimée." : "La matière <em>$nom</em> n'a pas pu être supprimée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }
    }

  }
  $mysqli->close();
}

//////////
// HTML //
//////////
// Haut de page, menu et message
$p = "matieres$urladmin2";
$t = 'Modifications des matieres';
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');
?>

  <div class="item aide">
    <h3>Aide et explications</h3>
    <p>Vous pouvez ci-dessous ajouter une matière ou modifier les matières existantes.</p>
    <p>L'ordre d'apparition des matières dans le menu est modifiable grâce aux flèches. Il s'agit du menu de la partie publique uniquement&nbsp;: si vous avez plusieurs matières dans votre interface d'administration, vous pouvez gérer leur ordre d'apparition dans <a href="prefs">vos préférences</a>.</p>
    <p>La suppression d'une matière n'est possible, afin d'éviter les erreurs de manipulation lourdes de conséquences, que si cela est sans conséquences. Il faut donc qu'aucun programme de colles/cahier de texte/document ne soit enregistré. Il faut aussi que cette matière n'apparaissent pas dans l'interface d'administration, pour tous les utilisateurs&nbsp;: chaque utilisateur peut faire ce choix dans ses préférences.</p>
    <h4>Préférences de chaque matière</h4>
    <p>Le <em>nom complet</em> s'affiche dans le menu et dans les titres des pages.</p>
    <p>La <em>clé dans l'adresse</em> est un mot-clé utilisé uniquement dans l'adresse des pages associées à la matière. Il vaut mieux que ce soit un mot unique, court et sans majuscule. Par exemple, «&nbsp;maths&nbsp;», «&nbsp;phys&nbsp;»...</p>
    <p>Les deux cases à cocher <em>Demande d'identification pour l'affichage...</em> permettent de restreindre la visibilité du programme de colles ou du cahier de texte aux visiteurs qui se sont identifiés. Dans ce cas, après <a href="utilisateurs">avoir créé un compte pour les élèves ici</a>, ces informations seront accessibles aux élèves auxquels vous aurez donné l'identifiant et le mot de passe choisis.</p>
    <p>Les liens vers le cahier de texte, les programmes de colles et les documents sont affichés automatiquement dans le menu de la partie publique, uniquement lorsqu'il y a derrière quelque chose à afficher.</p>
  </div>

<?php
// Fonction d'affichage
function affichage($r)  {
  if ( $id = $r['id'] )  {
    $debut = "Matière n°${r['ordre']}&nbsp;: ${r['nom']}";
    $valide1 = '';
    $valide = "\n      <input type=\"submit\" name=\"modifie\" value=\"Valider\" title=\"Valider les modifications\">";
    $monte = ( $r['ordre'] > 1 ) ? "\n      <input type=\"submit\" name=\"monte\" value=\"&uarr;\" title=\"Remonter la matière dans l'ordre d'apparition\">" : '';
    $descend = ( $r['ordre'] < $GLOBALS['max'] ) ? "\n      <input type=\"submit\" name=\"descend\" value=\"&darr;\" title=\"Descendre la matière dans l'ordre d'apparition\">" : '';
    if ( $r['nonvide'] )  {
      $suppr = ( $GLOBALS['max'] > 1 ) ? "\n      <input type=\"submit\" name=\"supprime\" value=\"Supprimer\" title=\"Supprimer la matière\" disabled>" : '';
      $indication = ( $GLOBALS['max'] > 1 ) ? "\n    <p>Cette matière ne peut pas être supprimée car ses programmes de colles, son cahier de texte ou des documents ne sont pas vides.</p>" : '';
    }
    else  {
      $suppr = ( $GLOBALS['max'] > 1 ) ? "\n      <input type=\"submit\" name=\"supprime\" value=\"Supprimer\" title=\"Supprimer la matière\">" : '';
      $indication = '';
    }
  }
  else  {
    $debut = 'Nouvelle matière';
    $valide1 = "\n    <input class=\"bouton\" type=\"submit\" name=\"modifie\" value=\"Valider\" title=\"Valider les modifications\">";
    $valide = $monte = $descend = $suppr = $indication = '';
  }
  echo <<<FIN
  <div class="item admin">
  <form action="" method="post">$valide1
    <h3>$debut</h3>
    <p class="boutons">$valide$monte$descend$suppr
    </p>
    <p class="ligne"><label for="nom$id">Nom complet&nbsp;: </label><input type="text" id="nom$id" name="nom" value="${r['nom']}" size="50"></p>
    <p class="ligne"><label for="cle$id">Clé dans l'adresse&nbsp;: </label><input type="text" id="cle$id" name="cle" value="${r['cle']}" size="30"></p>
    <p class="ligne"><label for="colles$id">Demande d'identification pour l'affichage du programme de colle</label><input type="checkbox" id="colles$id" name="colles" value="1"${r['colles']}></p>
    <p class="ligne"><label for="cdt$id">Demande d'identification pour l'affichage du cahier de texte</label><input type="checkbox" id="cdt$id" name="cdt" value="1"${r['cdt']}></p>
    <input type="hidden" name="id" value="$id">$indication
  </form>
  </div>


FIN;
}

// Formulaire vide pour une nouvelle matière et aide générale
affichage(array('id' => 0, 'ordre' => 0, 'cle' => 'cle_de_la_matiere', 'nom' => 'Nom de la matière', 'colles' => '', 'cdt' => ''));

// Affichage des matières existantes
$resultat = $mysqli->query('SELECT id, ordre, cle, nom, MOD(colles,2)+MOD(cdt,2)+docs AS nonvide,
                            IF(colles>1,\' checked\',\'\') AS colles, IF(cdt>1,\' checked\',\'\') AS cdt
                            FROM matieres');
$max = $resultat->num_rows;
$mysqli->close();
while ( $r = $resultat->fetch_assoc() )
  affichage($r);
$resultat->free();

// Bas de page
include('bas.php');
?>
